=== debian/changelog ===
ne10 (1.2.1-6) unstable; urgency=medium

  * Update for cmake 4. Closes: 1113315

 -- Wookey <wookey@debian.org>  Mon, 01 Sep 2025 11:47:04 +0100

ne10 (1.2.1-5) unstable; urgency=medium

  * Fix FTBFS with gcc10 (Closes: #987643)

 -- Wookey <wookey@debian.org>  Fri, 07 May 2021 03:57:03 +0000

ne10 (1.2.1-4) unstable; urgency=medium

  * Fix build for armhf (Closes: #905831)
  * Update to policy 4.3.0

 -- Wookey <wookey@debian.org>  Mon, 07 Jan 2019 03:44:54 +0000

ne10 (1.2.1-3) unstable; urgency=medium

  * Update copyright file for modules/*

 -- Wookey <wookey@debian.org>  Tue, 18 Oct 2016 18:01:22 +0100

ne10 (1.2.1-2) unstable; urgency=medium

  * Fix compiler warnings. Thanks to Joe Savage. (Issue 123 on github)

 -- Wookey <wookey@debian.org>  Wed, 12 Oct 2016 16:03:27 +0100

ne10 (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #837078)
  * Includes multiarch support

 -- Wookey <wookey@debian.org>  Mon, 05 Sep 2016 15:36:50 +0100
