=== debian/control ===
Source: ne10
Priority: optional
Maintainer: Wookey <wookey@debian.org>
Build-Depends: debhelper (>= 10.2.1), cmake, doxygen, texlive-latex-base, texlive-binaries, ghostscript
Standards-Version: 4.3.0
Section: libs
Homepage: http://projectne10.github.io/Ne10/
Rules-Requires-Root: no

Package: libne10-dev
Section: libdevel
Architecture: armhf arm64
Multi-Arch: same
Depends: libne10-10 (= ${binary:Version}), ${misc:Depends}
Description: ARM neon (SIMD) library - development files
 Ne10 is a library of the most commonly used functions that have been
 heavily optimized for ARM-based CPUs with NEON (ARM's SIMD
 instructions). These functions provide consistent, well tested
 behavior for use in applications without having to write assembly.
 Ne10 is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported. (ARM v7, 32-bit, armhf, and
 ARM v8, 64-bit, aarch64/arm64)
 .
 This package contains the development files (headers, static library)

Package: libne10-10
Architecture: armhf arm64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ARM neon (SIMD) library
 Ne10 is a library of the most commonly used functions that have been
 heavily optimized for ARM-based CPUs with NEON (ARM's SIMD
 instructions). These functions provide consistent, well tested
 behavior for use in applications without having to write assembly.
 Ne10 is usable as a shared or static library.
 .
 Both 32 and 64-bit variants are supported. (ARM v7, 32-bit, armhf, and
 ARM v8, 64-bit, aarch64/arm64)
