=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ 

override_dh_auto_configure:
	dh_auto_configure -- \
	-DNE10_LINUX_TARGET_ARCH=$(DEB_TARGET_GNU_CPU) \
	-DGNULINUX_PLATFORM=ON \
	-DNE10_BUILD_SHARED=ON

override_dh_auto_clean:
	-rm -r obj-* doc/doxygen/documentation
	dh_clean
