=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts="filenamemangle=s|.+\/v?(\d\S*)\.tar\.gz|ne10-$1\.tar\.gz|" \
  https://github.com/projectNe10/ne10/tags .*/v?(\d\S*)\.tar\.gz
